/*	Copyright (C) 1997 Eugene G. Crosser and Sovam Teleport		*/

#ifndef LINT
static char *rscid="$Id: mcs_readmap.c,v 1.3 1999/11/26 17:03:22 crosser Exp $";
#endif

/*
	$Log: mcs_readmap.c,v $
	Revision 1.3  1999/11/26 17:03:22  crosser
	Configure for sunos4
	
	Revision 1.2  1999/08/26 12:17:48  crosser
	Working automakified/libtoolized version
	
	Revision 1.1  1997/10/21 12:09:52  crosser
	Initial revision
	
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#ifdef STDC_HEADERS
#include <ctype.h>
#endif
#include "mcs.h"
#include "mcs_readmap.h"

#define ERROR		-1
#define COMPLETE	0
#define STARTUP		1
#define EXPECTCHAR	2
#define EXPECTQUOTE	3
#define EXPECTSPACE	4
#define EXPECTXORDIGIT	5
#define EXPECTDECDIGIT	6
#define EXPECTHEXDIGIT	7
#define EXPECTOCTDIGIT	8

extern int mcs_verbose;

static int
scan(char **p)
{
	int status;
	unsigned char c;
	int result=0;

	status=STARTUP;
	while (status>COMPLETE) {
	c=(unsigned char)*((*p)++);
#ifdef DEBUG
	if (mcs_verbose > 4) {
		if (c >= ' ') fprintf(stderr,"c='%c',s=%d-",c,status);
		else fprintf(stderr,"c=%d,s=%d-",c,status);
	}
#endif
	if (c == '\0') {
		status=ERROR;
	} else switch (status) {
	case STARTUP:
		switch (c) {
		case '\'':
			status=EXPECTCHAR;
			break;
		case '0':
			status=EXPECTXORDIGIT;
			break;
		case '1': case '2': case '3': case '4': case '5':
		case '6': case '7': case '8': case '9':
			status=EXPECTDECDIGIT;
			result=c-'0';
			break;
		default:
			status=ERROR;
			break;
		}
		break;
	case EXPECTCHAR:
		status=EXPECTQUOTE;
		result=c;
		break;
	case EXPECTQUOTE:
		if (c == '\'') {
			status=EXPECTSPACE;
		} else {
			status=ERROR;
		}
		break;
	case EXPECTSPACE:
		if (isspace(c)) {
			status=COMPLETE;
		} else {
			status=ERROR;
		}
		break;
	case EXPECTXORDIGIT:
		if ((c == 'x') || (c == 'X')) {
			status=EXPECTHEXDIGIT;
		} else if ((c >= '0')|| (c <= '7')) {
			status=EXPECTOCTDIGIT;
			result=c-'0';
		} else {
			status=ERROR;
		}
		break;
	case EXPECTDECDIGIT:
		if (isspace(c)) {
			status=COMPLETE;
		} else if ((c >= '0')|| (c <= '9')) {
			result*=10;
			result+=(c-'0');
		} else {
			status=ERROR;
		}
		break;
	case EXPECTHEXDIGIT:
		if (isspace(c)) {
			status=COMPLETE;
		} else if ((c >= '0')|| (c <= '9')) {
			result*=16;
			result+=(c-'0');
		} else if ((c >= 'a')|| (c <= 'f')) {
			result*=16;
			result+=(c-'a'+10);
		} else if ((c >= 'A')|| (c <= 'F')) {
			result*=16;
			result+=(c-'A'+10);
		} else {
			status=ERROR;
		}
		break;
	case EXPECTOCTDIGIT:
		if (isspace(c)) {
			status=COMPLETE;
		} else if ((c >= '0')|| (c <= '7')) {
			result*=8;
			result+=(c-'0');
		} else {
			status=ERROR;
		}
		break;
	}
#ifdef DEBUG
	if (mcs_verbose > 4) fprintf(stderr,"%d ",status);
#endif
	}
#ifdef DEBUG
	if (mcs_verbose > 4) fprintf(stderr,"r=%d\n",result);
#endif
	if (status != COMPLETE) return -1;
	else return result;
}

void
mcs_readmap(FILE *fp,mcs_table_t *tab)
{
	int i,lc=0;
	char buf[256];
	char *p;
	int left,right;

	for (i=0;i<256;i++) {
		tab->in[i]=i;
		tab->out[i]=i;
	}
	if (fp == NULL) return;
	while (fgets(buf,sizeof(buf),fp)) {
		lc++;
		p=buf;
		while (*p && isspace(*p)) p++;
		if (!*p || (*p == '#')) continue;
		left=scan(&p);
		while (*p && isspace(*p)) p++;
		right=scan(&p);
		if ((left >= 0) && (right >= 0) &&
		    (left < 256) && (right < 256)) {
			tab->out[left]=right;
			tab->in[right]=left;
		}
#ifdef DEBUG
		else if (mcs_verbose)
			fprintf(stderr,"bad line %d: %s",lc,buf);
#endif
	}
}
